package de.uni_heidelberg.ise.studentnavigator;

import com.hdm_i.dm.android.annotation.UserLocationAnnotation;
import com.hdm_i.dm.android.mapsdk.Annotation;
import com.hdm_i.dm.android.mapsdk.HDMVec3;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import de.uhd.ifi.se.feature.annotations.java.Feature;

@Feature("Routenfindung")
public class LocationHandler implements LocationListener {
    private static Location currentLocation;
    public static Location getCurrentLocation() {
        return currentLocation;
    }
    public static HDMVec3 getCurrentLocationAsVector() {
        return new HDMVec3(currentLocation.getLongitude(), currentLocation.getLatitude(),
                currentLocation.getAltitude());
    }

    private final MainActivity context;

    private Annotation currentPositionAnnotation;

    public LocationHandler(Context context) {
        this.context = (MainActivity) context;
        ((LocationManager) context.getSystemService(Context.LOCATION_SERVICE))
                .requestLocationUpdates(LocationManager.GPS_PROVIDER, 100, 1, this);
    }

    @Override
    public void onLocationChanged(Location l) {
        if (currentLocation != null && currentPositionAnnotation != null){
        	context.getDeepMap().removeAnnotation(currentPositionAnnotation);
        }
        currentLocation = l;
        currentPositionAnnotation = new UserLocationAnnotation(context, currentLocation.getLongitude(),
                currentLocation.getLatitude(), 1);
        context.getDeepMap().addAnnotation(currentPositionAnnotation);
    }

    @Override
    public void onProviderDisabled(String provider) {
    }

    @Override
    public void onProviderEnabled(String provider) {
    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {
    }
}
