package de.uni_heidelberg.ise.studentnavigator;

import com.hdm_i.dm.android.mapsdk.HDMRoutingPathFeature;

import android.app.Activity;
import android.widget.TextView;
import de.uhd.ifi.se.feature.annotations.java.Feature;

@Feature("Routenfindung")
public class NavigationInfoManger {
    private final TextView distanceView;

    private final TextView durationView;
    private final double minutesPerMeter = 0.015;

    public NavigationInfoManger(Activity context) {
        this.durationView = (TextView) context.findViewById(R.id.navigation_duration);
        this.distanceView = (TextView) context.findViewById(R.id.navigation_distance);
    }

    public void setNavigationContent(HDMRoutingPathFeature route) {
        final double routeLength = route.getLength();
        final int lengthRounded = (int) Math.round(routeLength);
        durationView.setText((int) Math.round(routeLength * minutesPerMeter) + StringConstants.minutesShort);
        distanceView.setText(lengthRounded + StringConstants.metersShort);
    }
}
