package de.uni_heidelberg.ise.studentnavigator;

import java.util.ArrayList;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import de.uhd.ifi.se.feature.annotations.java.Feature;
import de.uni_heidelberg.ise.studentnavigator.extern.RnvDeparture;

@Feature("opnv")
public class RnvDepartureArrayAdapter extends ArrayAdapter<RnvDeparture> {
    Context context;

    public RnvDepartureArrayAdapter(Context context, ArrayList<RnvDeparture> arrayList) {
        super(context, R.layout.layout_departure_list_item, arrayList);
        this.context = context;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        final View rowView = ((LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE)).inflate(R.layout.layout_departure_list_item, parent, false);
        ((TextView) rowView.findViewById(R.id.label_line)).setText(getItem(position).getLineLabel());
        ((TextView) rowView.findViewById(R.id.summary)).setText(getItem(position).toSummary());
        ((TextView) rowView.findViewById(R.id.pole)).setText(getItem(position).getPlatform());
        rowView.findViewById(R.id.status);
        return rowView;
    }

    public void onAddItem(RnvDeparture item) {
        this.add(item);
        notifyDataSetChanged();
    }

    public void onRemove(RnvDeparture item) {
        remove(item);
        notifyDataSetChanged();
    }
}
