package de.uni_heidelberg.ise.studentnavigator;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import de.uhd.ifi.se.feature.annotations.java.Feature;
import de.uni_heidelberg.ise.studentnavigator.model.MapObject;
import de.uni_heidelberg.ise.studentnavigator.model.api.DataManager;
import de.uni_heidelberg.ise.studentnavigator.model.api.IDataManager;
import de.uni_heidelberg.ise.studentnavigator.model.api.ISearchable;

@Feature("Routenfindung")
public class SearchManager {
    private final IDataManager dataManager;

    public SearchManager(Activity context) {
        dataManager = new DataManager(((MainActivity) context).getDataBaseHelper().getConnectionSource());
    }

    ISearchable searchByFid(String featureId) {
        final List<? extends MapObject> resultOffices = dataManager.getOffices(),
                resultToilets = dataManager.getToilets(), resultEventLocations = dataManager.getEventLocations(),
                resultBuildings = dataManager.getBuildings();
        final List<MapObject> result = new ArrayList<MapObject>(resultOffices);
        result.addAll(resultToilets);
        result.addAll(resultEventLocations);
        result.addAll(resultBuildings);

        for (final MapObject mapObject : result)
            if (mapObject.getFeatureId().equals(featureId))
                return (ISearchable) mapObject;

        return null;
    }

    List<ISearchable> searchFor(String query, String filter) {
        return dataManager.search(query, filter);
    }
}
