package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.Locale;

import com.j256.ormlite.dao.ForeignCollection;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.field.ForeignCollectionField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;
import de.uni_heidelberg.ise.studentnavigator.model.api.ISearchable;

/**
 * Created by henrik on 11.10.17. 
 */
@DatabaseTable(tableName = "buildings")
@Feature("Routenfindung")
public class Building extends MapObject implements ISearchable {
    @DatabaseField
    private String address;
    @DatabaseField
    private String name;
    @ForeignCollectionField(eager = true)
    private ForeignCollection<Period> periods;

    public Building() {
    }

    public Building(String name, String address, String featureId) {
        setFeatureId(featureId);
        this.name = name;
        this.address = address;
    }

    @Override
    public boolean contains(String search) {
        return (getSearchableTitle() + " " + getSearchableDescription()).toLowerCase(Locale.ENGLISH)
                .contains(search.toLowerCase(Locale.ENGLISH));
    }

    public String getAddress() {
        return address;
    }

    @Override
    public MapObject getMapObject() {
        return this;
    }

    public String getName() {
        return name;
    }

    @Override
    public String getSearchableDescription() {
        return this.address;
    }

    @Override
    public String getSearchableTitle() {
        return this.name;
    }

    @Override
    public void setFeatureId(String featureId) {
        this.featureId = featureId;
    }
}
