package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.List;

import com.j256.ormlite.dao.ForeignCollection;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.field.ForeignCollectionField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;

@DatabaseTable(tableName = "events")
@Feature("Routenfindung")
public class Event {
    @DatabaseField
    private String description;
    @DatabaseField(foreign = true, foreignAutoRefresh = true)
    private EventLocation eventLocation;
    /**
    * This field is needed for persistence (e.g. as foreign key) 
    */
    @DatabaseField(generatedId = true)
    private Long id;
    private List<Organizer> organizer;
    @ForeignCollectionField(eager = true)
    private ForeignCollection<Period> periods;

    public Event() {
    }

    public Event(EventLocation eventLocation, String description) {
        setEventLocation(eventLocation);
        this.description = description;
    }

    public Event(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public EventLocation getEventLocation() {
        return eventLocation;
    }

    public Long getId() {
        return this.id;
    }

    public List<Organizer> getOrganizer() {
        return organizer;
    }

    public ForeignCollection<Period> getPeriods() {
        return periods;
    }

    public void setEventLocation(EventLocation l) {
        this.eventLocation = l;
    }

    public void setOrganizer(List<Organizer> os) {
        this.organizer = os;
    }
}
