package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.Locale;

import com.j256.ormlite.dao.ForeignCollection;
import com.j256.ormlite.field.ForeignCollectionField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;

@DatabaseTable(tableName = "event_locations")
@Feature("Routenfindung")
public class EventLocation extends Room {
    @ForeignCollectionField(eager = true)
    private ForeignCollection<Event> events;

    public EventLocation() {
    }

    public EventLocation(String name, Building building, Organization organization, String featureId) {
        super(name, building, organization, featureId);
    }

    @Override
    public boolean contains(String search) {
        return (getSearchableTitle() + " " + getSearchableDescription()).toLowerCase(Locale.ENGLISH)
                .contains(search.toLowerCase(Locale.ENGLISH));
    }

    public String getEventBuilding() {
        return getBuilding().getName();
    }

    public String getEventName() {
        return getName();
    }

    public String getEventOrganization() {
        return getOrganization().getName();
    }

    public ForeignCollection<Event> getEvents() {
        return events;
    }

    @Override
    public MapObject getMapObject() {
        return this;
    }

    @Override
    public String getSearchableDescription() {
        return getBuilding().getName();
    }

    @Override
    public String getSearchableTitle() {
        return getName();
    }
}
