package de.uni_heidelberg.ise.studentnavigator.model;

import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;

@DatabaseTable(tableName = "event_organizations")
@Feature("Routenfindung")
public class EventOrganization {
    @DatabaseField(foreign = true)
    Event event;
    /**
    * This field is needed for persistence (e.g. as foreign key) 
    */
    @DatabaseField(generatedId = true)
    private Long id;
    @DatabaseField(foreign = true)
    Organization organization;
    @DatabaseField(foreign = true)
    Person person;

    public EventOrganization() {
    }

    public EventOrganization(Event event, Organizer organizer) {
        this.event = event;
        if (organizer instanceof Person)
            this.person = (Person) organizer;
        else
            this.organization = (Organization) organizer;
    }

    public Organization getOrganization() {
        return organization;
    }

    public Person getPerson() {
        return person;
    }
}
