package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import com.j256.ormlite.dao.ForeignCollection;
import com.j256.ormlite.field.ForeignCollectionField;

import de.uhd.ifi.se.feature.annotations.java.Feature;

@Feature("Routenfindung")
public class Office extends Room {
    @ForeignCollectionField(eager = true)
    private ForeignCollection<Person> persons;

    public Office() {
    }

    public Office(ForeignCollection<Person> persons, String name, Building building, Organization organization,
            String featureId) {
        super(name, building, organization, featureId);
        this.persons = persons;
    }

    public Office(String name, Building building, Organization organization, String featureId) {
        super(name, building, organization, featureId);
    }

    public void addPerson(Person p) {
        this.persons.add(p);
    }

    @Override
    public boolean contains(String search) {
        return (getSearchableTitle() + " " + getSearchableDescription()).toLowerCase(Locale.ENGLISH)
                .contains(search.toLowerCase(Locale.ENGLISH));
    }

    @Override
    public MapObject getMapObject() {
        return this;
    }

    public String getOfficeBuilding() {
        return getBuilding().getName();
    }

    public Organization getOfficeOrganization() {
        return getOrganization();
    }

    public String getOfficeRoom() {
        return getName();
    }

    public List<Person> getPersons() {
        final Iterator<Person> iterator = persons.iterator();
        final ArrayList<Person> persons = new ArrayList<Person>();
        while (iterator.hasNext())
            persons.add(iterator.next());
        return persons;
    }

    @Override
    public String getSearchableDescription() {
        return getBuilding().getName();
    }

    @Override
    public String getSearchableTitle() {
        return getName();
    }
}
