package de.uni_heidelberg.ise.studentnavigator.model;

import com.j256.ormlite.field.DatabaseField;

import de.uhd.ifi.se.feature.annotations.java.Feature;
import de.uni_heidelberg.ise.studentnavigator.model.api.ISearchable;

@Feature("Routenfindung")
public abstract class Room extends MapObject implements ISearchable {
    @DatabaseField(foreign = true, canBeNull = false, foreignAutoRefresh = true)
    private Building building;

    @DatabaseField
    private String name;

    @DatabaseField(foreign = true, foreignAutoRefresh = true)
    private Organization organization;

    public Room() {
    }

    public Room(String name, Building building, Organization organization, String featureId) {
        this.name = name;
        this.building = building;
        this.organization = organization;
        setFeatureId(featureId);
    }

    public Building getBuilding() {
        return building;
    }

    public String getName() {
        return name;
    }

    public Organization getOrganization() {
        return organization;
    }

    @Override
    public void setFeatureId(String featureId) {
        this.featureId = featureId;
    }
}
