package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.Locale;

import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;
import de.uni_heidelberg.ise.studentnavigator.model.api.ISearchable;

@DatabaseTable(tableName = "stations")
@Feature({"opnv","Routenfindung"})
public class Station extends MapObject implements ISearchable {
    @DatabaseField
    private String hafasID;
    @DatabaseField
    private String longName;
    @DatabaseField
    private String shortName;

    public Station() {
    }

    public Station(String opnvId, String featureId, String longName, String shortName) {
        this.hafasID = opnvId;
        setFeatureId(featureId);
        this.longName = longName;
        this.shortName = shortName;
    }

    public String getHafasID() {
        return hafasID;
    }

    public String getLongName() {
        return this.longName;
    }

    public String getShortName() {
        return this.shortName;
    }

    @Override
    public void setFeatureId(String featureId) {
        this.featureId = featureId;
    }

	@Override
	public boolean contains(String search) {
		return (getSearchableTitle() + " " + getSearchableDescription()).toLowerCase(Locale.ENGLISH)
        .contains(search.toLowerCase(Locale.ENGLISH));
	}

	@Override
	public MapObject getMapObject() {
		return this;
	}

	@Override
	public String getSearchableDescription() {
		return this.shortName;
	}

	@Override
	public String getSearchableTitle() {
		return this.longName;
	}
}