package de.uni_heidelberg.ise.studentnavigator.model;

import java.util.Locale;

import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;

import de.uhd.ifi.se.feature.annotations.java.Feature;

@DatabaseTable(tableName = "toilets")
@Feature("Routenfindung")
public class Toilet extends Room {
    public enum Type {
        /** Unisex. */
        DISABLED("Barrierefrei"),
        FEMALE("Frauen"),
        /** Female. */
        MALE("Männer"),
        /** Male. */
        UNISEX("Unisex");
        /** Disabled. */
        private String name;

        private Type(String name) {
            this.name = name;
        }

        public String getName() {
            return name;
        }
    }

    @DatabaseField(dataType = DataType.ENUM_STRING)
    private Type type;

    public Toilet() {
    }

    public Toilet(Type type, String name, Building building, Organization organization, String featureId) {
        super(name, building, organization, featureId);
        this.type = type;
    }

    @Override
    public boolean contains(String search) {
        return (getSearchableTitle() + " " + getSearchableDescription()).toLowerCase(Locale.ENGLISH)
                .contains(search.toLowerCase(Locale.ENGLISH));
    }

    public String getBuildingName() {
        return getBuilding().getName();
    }

    @Override
    public MapObject getMapObject() {
        return this;
    }

    @Override
    public String getSearchableDescription() {
        return getBuilding().getName();
    }

    @Override
    public String getSearchableTitle() {
        return getName();
    }

    public String getToiletName() {
        return getName();
    }

    public Type getType() {
        return type;
    }
}
